Subject: [mpls] ECMP and RFC 4379

From: David Charlap <[email-masked]>
Date: Thu, 29 Oct 2009 14:16:17 -0400

In section 4.1 of RFC 4379, it discusses equal-cost multi-path (ECMP) in the context of MPLS.

I am familiar with the concept of ECMP for a traditional IP forwarder - the route table contains multiple next-hops for a prefix and the forwarder selects one on a per-packet basis, using some kind of hash to ensure that individual flows follow a single path, to prevent out-of-order delivery as much as possible.

I don't remember any discussion of this within the context of MPLS.  I am aware of the concept of point-to-multipoint LSPs, but these are multicast constructs, not ECMP.  When a cross-connect has multiple out-segments, matching traffic is forwarded on all of those out-segments.  I don't know of any situation where the forwarder would select only one out-segment for forwarding.

Ditto for signaling protocols.  I'm aware of the RFCs for supporting multicast LSPs with RSVP-TE and LDP, but I am unaware of any work to implement ECMP within a single LSP.  The idea of using multiple LSPs (tunnel instances, etc.) for load balancing is fairly straightforward, but that's not what ECMP implies.

So, my question is: What is section 4.1 of RFC 4379 really referring to?  If it is talking about a single LSP following multiple paths with an MPLS forwarder implementing ECMP behavior, are there any drafts or RFCs describing this behavior or how signaling protocols are expected to support it?

Thanks in advance.

-- David

---

From: Vishwas Manral <[email-masked]>
Date: Thu, 29 Oct 2009 11:26:45 -0700

Hi David,

>   When a cross-connect has multiple out-segments,
> matching traffic is forwarded on all of those out-segments.  I don't know of
> any situation where the forwarder would select only one out-segment for
> forwarding.
In the MPLS ECMP case, just like all other ECMP cases (IP ECMP etc)
the packet is sent on one of the paths based on the fact that we do
not reorder flows.

There should be no change to LDP signalling for the same. I do not
think there are any drafts for the same.

Thanks,
Vishwas

On Thu, Oct 29, 2009 at 11:16 AM, David Charlap
<[email-masked]> wrote:
> I am familiar with the concept of ECMP for a traditional IP forwarder - the
> route table contains multiple next-hops for a prefix and the forwarder
> selects one on a per-packet basis, using some kind of hash to ensure that
> individual flows follow a single path, to prevent out-of-order delivery as
> much as possible.
>
> I don't remember any discussion of this within the context of MPLS.  I am
> aware of the concept of point-to-multipoint LSPs, but these are multicast
> constructs, not ECMP.  When a cross-connect has multiple out-segments,
> matching traffic is forwarded on all of those out-segments.  I don't know of
> any situation where the forwarder would select only one out-segment for
> forwarding.
>
> Ditto for signaling protocols.  I'm aware of the RFCs for supporting
> multicast LSPs with RSVP-TE and LDP, but I am unaware of any work to
> implement ECMP within a single LSP.  The idea of using multiple LSPs (tunnel
> instances, etc.) for load balancing is fairly straightforward, but that's
> not what ECMP implies.
>
> So, my question is: What is section 4.1 of RFC 4379 really referring to?  If
> it is talking about a single LSP following multiple paths with an MPLS
> forwarder implementing ECMP behavior, are there any drafts or RFCs
> describing this behavior or how signaling protocols are expected to support
> it?
>
> Thanks in advance.
>
> -- David
>
> _______________________________________________
> mpls mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mpls
>
>